
import upygame as upygame
#import framebuf
import urandom as random
import umachine as pok
import graphics 
import sounds

upygame.display.init()
screen_sf = upygame.display.set_mode() # full screen

# Initialize sound
g_sound = upygame.mixer.Sound()
g_sound.reset()
g_sound.play()

#debug
debug = 0

# Set palette
#upygame.display.set_palette_16bit([4124,0x155a,0xf800,65535, 0x0000, 0x4901, 0x82a4, 0xee2a, 0x0e01, 0x0222, 0x73ce,0xad75,]);
upygame.display.set_palette_16bit([4124,0x155a,0xf800,65535, 0x0000, 0x4901, 0x82a4, 0xee47, 0x0e01, 0x0222, 0x73ce,0xad75,]);


texts = [\
"Pyrates!",
"Landed",
"Crashed!",
"Welcome to \nPort Grog!!",
"by Jonne",
"L,R to steer",
"C to restart",
"Land ahoy!",
"North!",
"East!",
"South!",
"West!",
"press A",
"A to leave \n port",
"Low on grog,",
"Cap'n!",
"Out of grog!",
"Game Over!",
"Ship ahoy!",
]
land_ahoy_counter = 0
ship_ahoy_counter = 0
ahoy_dir = 0
player_cannon_counter = 0
enemy_cannon_counter= 0

class Shot:
  def __init__(self, dir, x, y):
    self.dir = dir
    self.x = x
    self.y = y

# island , first line is width, height, co-ords of port, port entry direction
island = [\
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],\
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],\
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],\
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],\
]

islandport = [5,5,-1,-1,-1,-1]
islandsize = 16
                
#Create graphics surfaces
sea_sf = upygame.surface.Surface(16, 16, graphics.seaPixels)
sea_sf2 = upygame.surface.Surface(16, 16, graphics.seaPixels2)
cloud_sf = upygame.surface.Surface(40, 28, graphics.cloudPixels)
wake_sf = upygame.surface.Surface(8, 6, graphics.wakePixels)
wake2_sf = upygame.surface.Surface(8, 6, graphics.wakePixels2)
flag_sf = upygame.surface.Surface(4, 4, graphics.flagPixels)
flag2_sf = upygame.surface.Surface(4, 4, graphics.flagPixels2)
rflag_sf = upygame.surface.Surface(4, 4, graphics.rflagPixels)
rflag2_sf = upygame.surface.Surface(4, 4, graphics.rflagPixels2)
yflag_sf = upygame.surface.Surface(4, 4, graphics.yflagPixels)
yflag2_sf = upygame.surface.Surface(4, 4, graphics.yflagPixels2)
wflag_sf = upygame.surface.Surface(4, 4, graphics.wflagPixels)
wflag2_sf = upygame.surface.Surface(4, 4, graphics.wflagPixels2)
hull_n = upygame.surface.Surface(14, 14, graphics.hull_nPixels)
hull_ne = upygame.surface.Surface(14, 14, graphics.hull_nePixels)
hull_nw = upygame.surface.Surface(14, 14, graphics.hull_nwPixels)
hull_s = upygame.surface.Surface(14, 14, graphics.hull_sPixels)
hull_se = upygame.surface.Surface(14, 14, graphics.hull_sePixels)
hull_sw = upygame.surface.Surface(14, 14, graphics.hull_swPixels)
hull_e = upygame.surface.Surface(14, 14, graphics.hull_ePixels)
hull_w = upygame.surface.Surface(14, 14, graphics.hull_wPixels)
sail_n = upygame.surface.Surface(14, 14, graphics.sail_nPixels)
sail_w = upygame.surface.Surface(14, 14, graphics.sail_wPixels)
sail_e = upygame.surface.Surface(14, 14, graphics.sail_ePixels)
sail_broken = upygame.surface.Surface(14, 14, graphics.sail_brokenPixels)
land1 = upygame.surface.Surface(8, 8, graphics.land1Pixels)
land2 = upygame.surface.Surface(8, 8, graphics.land2Pixels)
land3 = upygame.surface.Surface(8, 8, graphics.land3Pixels)
land4 = upygame.surface.Surface(8, 8, graphics.land4Pixels)
land5 = upygame.surface.Surface(8, 8, graphics.land5Pixels)
land6 = upygame.surface.Surface(8, 8, graphics.land6Pixels)
land7 = upygame.surface.Surface(8, 8, graphics.land7Pixels)
land8 = upygame.surface.Surface(8, 8, graphics.land8Pixels)
land9 = upygame.surface.Surface(8, 8, graphics.land9Pixels)
wind0 = upygame.surface.Surface(8, 7, graphics.wind0Pixels)
wind1 = upygame.surface.Surface(8, 7, graphics.wind1Pixels)
wind2 = upygame.surface.Surface(8, 7, graphics.wind2Pixels)
wind3 = upygame.surface.Surface(8, 7, graphics.wind3Pixels)
wind4 = upygame.surface.Surface(8, 7, graphics.wind4Pixels)
wind5 = upygame.surface.Surface(8, 7, graphics.wind5Pixels)
wind6 = upygame.surface.Surface(8, 7, graphics.wind6Pixels)
wind7 = upygame.surface.Surface(8, 7, graphics.wind7Pixels)
port = upygame.surface.Surface(14, 12, graphics.portPixels)
rocks = upygame.surface.Surface(8, 8, graphics.rocksPixels)
rocks2 = upygame.surface.Surface(8, 8, graphics.rocks2Pixels)
crash = upygame.surface.Surface(14, 12, graphics.crashedPixels)
grog_sf = upygame.surface.Surface(8, 8, graphics.grogPixels)
coin = upygame.surface.Surface(8, 8, graphics.coinPixels)
shots = upygame.surface.Surface(10, 11, graphics.shotsPixels)
shotm = upygame.surface.Surface(10, 11, graphics.shotmPixels)
shotl = upygame.surface.Surface(10, 11, graphics.shotlPixels)
projlo = upygame.surface.Surface(4, 8, graphics.projloPixels)
projhi = upygame.surface.Surface(4, 8, graphics.projhiPixels)
splash = upygame.surface.Surface(8, 8, graphics.splashPixels)
boom = upygame.surface.Surface(8, 8, graphics.boomPixels)

#           wind direction
#           0   1   2   3   4   5   6   7
#ship   0   3   4...
#dir.   1   4   3
#       2   2   4
#       3   1   2
#       4   0   1
#       5   1   0
#       6   2   1
#       7   4   2
windangle =[\
[ 3, 4, 2, 1,-1, 1, 2, 4],\
[ 4, 3, 4, 2, 1,-1, 1, 2],\
[ 2, 4, 3, 4, 2, 1,-1, 1],\
[ 1, 2, 4, 3, 4, 2, 1,-1],\
[-1, 1, 2, 4, 3, 4, 2, 1],\
[ 1,-1, 1, 2, 4, 3, 4, 2],\
[ 2, 1,-1, 1, 2, 4, 3, 4],\
[ 4, 2, 1,-1, 1, 2, 4, 3]\
]

#random rocks
rocks_x = [0,0,0,0,0,0]
rocks_y = [0,0,0,0,0,0]

#sea array
sea_x = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
sea_y = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
sea_k = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
#camera
cam_x = 0
cam_y = 0
ocam_x = 0
ocam_y = 0
#cloud
cloud_x = 33 #110 + random.getrandbits(7) 
cloud_y = 33 #random.getrandbits(6) 
cloud_vx = 0
cloud_vy = 0
#island
is_x = 44*5
is_y = 44*1
#port
port_y = 0
port_x = 0
port_visited = 0
port_grog = 4000
#ship
ship_wx = 44*2
ship_wy = 44*3
ship_x = ship_wx // 2
ship_y = ship_wy // 2
ship_dir = 2
ship_vy = 0
ship_vx = 0
ship_landed = 4
ship_nudge = 0
ship_health = 5
#projectiles
smoke_wx = 0
smoke_wy = 0
projectile_wx = 0
projectile_wy = 0
projectile_dx = 0
projectile_dy = 0
#enemy
enemy_wx = -1000
enemy_wy = -1000
enemy_x = 10
enemy_y = 10
enemy_vx = 0
enemy_vy = 0
enemy_dir = 2
enemy_life = 10
enemy_health = 5
enemy_slowdown = 6
enemy_type = 0
enemy_loot = 0
esmoke_wx = 0
esmoke_wy = 0
eprojectile_wx = 0
eprojectile_wy = 0
eprojectile_dx = 0
eprojectile_dy = 0


#stats
grog=4000
points=500
#wind
wind_dir = 0
wind_strength = 3

#randomize island
def initisland():
    global islandsize
    global port_visited
    global port_grog
    port_visited = 0
    port_grog = 4000
    islandsize = random.getrandbits(1)*8+8
    peaks_i = []
    peaks_j = []
    #empty array
    while len(peaks_i) > 0 : 
        peaks_i.pop()
        peaks_j.pop()
    for i in range (0,islandsize):
        for j in range (0,islandsize):
            island[i][j] = ' '
    #add random peaks
    peaks = random.getrandbits(islandsize//4)+2
    #print(str(peaks))
    for i in range(0,peaks):
        _a = random.getrandbits(5)%islandsize
        _b = random.getrandbits(5)%islandsize
        peaks_i.append(_a)
        peaks_j.append(_b)
        #print(str(_a) + "," + str(_b))
        island[_a][_b] = '#'
    #connect peaks by lines
    for i in range(0,peaks):
        _tx = peaks_i[i] 
        _ty = peaks_j[i]
        if ( i < peaks-1):
            _ex = peaks_i[i+1] 
            _ey = peaks_j[i+1]
        else:
            _ex = peaks_i[0]
            _ey = peaks_j[0]
        #print("i:" + str(i))
        #print("tx:" + str(_tx) + ", ty:" + str(_ty) + ", ex:" + str(_ex) + ", ey:" + str(_ey))
        while (_tx != _ex or _ty != _ey):
            _dx = _ex -_tx
            _dy = _ey -_ty
            #print("tx:" + str(_tx) + ", ty:" + str(_ty))
            if (abs(_dx)>abs(_dy)):
                if (_dx<0): 
                    _tx = _tx - 1
                else:
                    _tx = _tx + 1
            else:
                if (_dy<0): 
                    _ty = _ty - 1
                else:
                    _ty = _ty + 1
            _thickness = random.getrandbits(3)
            if (_thickness==1):
                island[_ty][_tx] = '#'
            if (_thickness == 2):
                island[_ty][_tx] = '#'
                island[(_ty)%islandsize][(_tx+1)%islandsize] = '#'
                island[(_ty+1)%islandsize][(_tx+1)%islandsize] = '#'
                island[(_ty+1)%islandsize][(_tx)%islandsize] = '#'
            if (_thickness == 3):
                _tx = (_tx+1)%islandsize
                island[_ty][_tx] = '#'
                island[(_ty)%islandsize][(_tx+1)%islandsize] = '#'
                island[(_ty+1)%islandsize][(_tx+1)%islandsize] = '#'
                island[(_ty+1)%islandsize][(_tx)%islandsize] = '#'
                _ty = (_ty+1)%islandsize
                island[_ty][_tx] = '#'
                island[(_ty)%islandsize][(_tx+1)%islandsize] = '#'
                island[(_ty+1)%islandsize][(_tx+1)%islandsize] = '#'
                island[(_ty+1)%islandsize][(_tx)%islandsize] = '#'
                
    #create coastline
    #lost craggles on the edges become rocks
    for i in range(0,islandsize):
            if (island[0][i] == '#'):
                if (random.getrandbits(2)):
                    island[0][i] = 'R'
                else:
                    island[0][i] = ' '
            if (island[islandsize-1][i] == '#'):
                if (random.getrandbits(2)):
                    island[islandsize-1][i] = 'R'
                else:
                    island[islandsize-1][i] = ' '
            if (island[i][0] == '#'):
                if (random.getrandbits(2)):
                    island[i][0] = 'R'
                else:
                    island[i][0] = ' '
            if (island[i][islandsize-1] == '#'):
                if (random.getrandbits(2)):
                    island[i][islandsize-1] = 'R'
                else:
                    island[i][islandsize-1] = ' '
            
    #top edges
    for i in range(1,islandsize-1):
        for j in range(1,islandsize-1):
            if (island[i][j] == '#'):
                if (island[i-1][j] == ' ' or i == 1):
                    if (island[i][j-1] == ' ' or j == 1):
                        island[i][j] = '1'
                    else:
                        if (island[i][j+1] == ' ' or j == islandsize-1):
                            island[i][j] = '3'
                        else:
                            island[i][j] = 'T'
    #bottom edges
    for i in range(1,islandsize-1):
        for j in range(1,islandsize-1):
            if (island[i][j] == '#'):
                if (island[i+1][j] == ' ' or island[i+1][j] == 'R' or i == islandsize-1):
                    if (island[i][j-1] == ' ' or j == 1):
                        island[i][j] = '7'
                    else:
                        if (island[i][j+1] == ' ' or island[i][j+1] == 'R' or j == islandsize-1):
                            island[i][j] = '9'
                        else:
                            island[i][j] = 'B'
    #reform stranded bits into islands
    for i in range(0,islandsize-1):
        for j in range(0,islandsize):
            if (island[i][j] == '1'):
                if (island[i+1][j] != "#"):
                    island[i+1][j] = "7"
    for i in range(0,islandsize-1):
        for j in range(0,islandsize-1):
            if (island[i][j] == '1'):
                if (island[i][j+1] == " "):
                    island[i][j+1] = "3"
    for i in range(0,islandsize-1):
        for j in range(0,islandsize):
            if (island[i][j] == '3'):
                if (island[i+1][j] != "#"):
                    island[i+1][j] = "9"
    for i in range(0,islandsize-1):
        for j in range(1,islandsize):
            if (island[i][j] == '9'):
                if (island[i][j-1] == " "):
                    island[i][j-1] = "7"
    #final cleanup
    for i in range(0,islandsize):
        for j in range(0,islandsize-1):
            if (island[i][j] == '1' and island[i][j+1] != "#" and island[i][j+1] != "3" and island[i][j+1] != "T"): 
                island[i][j] = " "
            if (island[i][j] == '7' and island[i][j+1] != "#" and island[i][j+1] != "9" and island[i][j+1] != "B"): 
                island[i][j] = " "
    for i in range(1,islandsize-1):
        for j in range(1,islandsize-1):
            if (island[i][j] == '#' and (island[i][j-1] == " " or island[i][j-1] == "R") and (island[i][j+1] == " " or island[i][j+1] == "R")): 
                island[i][j] = " "
            elif (island[i][j] == '#' and (island[i][j-1] == " " or island[i][j-1] == "R")):
                island[i][j] = "W"
            elif (island[i][j] == '#' and (island[i][j+1] == " " or island[i][j+1] == "R")):
                island[i][j] = "E"
    
    #place the port
    #numports = 
    portplaced = 0
    tries = 10
    while(portplaced == 0 and tries):
        tries = tries - 1
        trial_col = random.getrandbits(8)%islandsize-1
        trialdir = random.getrandbits(2)
        if (trialdir == 0):
            #print("trialdir 0")
            for i in range(1,islandsize-1):
                if (island[trial_col][i] == '#' or island[trial_col][i] == '1'): # W to E
                    islandport[0] = i-1
                    islandport[1] = trial_col
                    portplaced = portplaced + 1
        elif (trialdir == 1):
            #print("trialdir 1")
            for i in range(islandsize-1,1,-1):
                if (island[trial_col][i] == '#' ):#or island[trial_col][i] == 'E'): # E to W
                    islandport[0] = i+1
                    islandport[1] = trial_col
                    portplaced = portplaced + 1
        elif (trialdir == 2):
            for i in range(1,islandsize-1):
                #print("trialdir 2")
                if (island[i][trial_col] == '#' ):#or island[trial_col][i] == 'T'): # T to B
                    islandport[1] = i-1
                    islandport[0] = trial_col
                    portplaced = portplaced + 1
        elif (trialdir == 3):
            #print("trialdir 3")
            for i in range(islandsize-1,1,-1):
                if (island[i][trial_col] == '#' ):#or island[trial_col][i] == 'B'): # B to T
                    islandport[1] = i+1
                    islandport[0] = trial_col
                    portplaced = portplaced + 1
        if (portplaced):
            if (islandport[0]<1 or islandport[1]<1 or islandport[0]>islandsize-1 or islandport[1]>islandsize-1):
                portplaced=0
            _x = islandport[0]
            _y = islandport[1]
            if(island[_x-1][_y]==' ' and island[_x+1][_y]==' '):
                portplaced=0
    #print(str(islandport[0])+","+str(islandport[1]))
    if (tries==0):
        islandport[0] = 200 #no port place found, move way out of sight
        islandport[1] = 200

def initrocks(_x,_y):
    for i in range(0,6):
        rocks_x[i] = (random.getrandbits(4))*6
        rocks_y[i] = (random.getrandbits(4))*6

def initwind():
    global wind_strength
    global wind_dir
    global cloud_vx 
    global cloud_vy
    if (wind_strength == 0):
        wind_dir = (random.getrandbits(3) + 1)%8
    else:
        if (random.getrandbits(1) == 0):
            wind_dir = wind_dir + random.getrandbits(3)
            if wind_dir > 7:
                wind_dir = 0
        else:
            wind_dir = wind_dir - random.getrandbits(3)
            if (wind_dir < 0):
                wind_dir = 7
        
    wind_strength = random.getrandbits(2) + 2
    if (wind_strength > 3):
        wind_strength = 3 # 5 was a bit too much
    #set cloud speed
    if wind_dir == 0:
        cloud_vx = 0
        cloud_vy = -wind_strength
    elif wind_dir == 1:
        cloud_vx = wind_strength // 2
        cloud_vy = - wind_strength // 2
    elif wind_dir == 2:
        cloud_vx = wind_strength
        cloud_vy = 0
    elif wind_dir == 3:
        cloud_vx = wind_strength // 2
        cloud_vy = wind_strength // 2
    elif wind_dir == 4:
        cloud_vx = 0
        cloud_vy = wind_strength 
    elif wind_dir == 5:
        cloud_vx = -wind_strength // 2
        cloud_vy = wind_strength // 2
    elif wind_dir == 6:
        cloud_vx = -wind_strength
        cloud_vy = 0
    elif wind_dir == 7:
        cloud_vx = - wind_strength // 2
        cloud_vy = - wind_strength // 2
    
    global debug
    if (debug == 1):
        wind_dir = 4
        wind_strength = 4
        
def movecloud():
    global cloud_x
    global cloud_y
    global cam_x
    global cam_y
    global ocam_x
    global ocam_y
    
    #camera change
    #cloud_x = cloud_x + ocam_x - cam_x
    #cloud_y = cloud_y + ocam_y - cam_y
    
    #wind change
    cloud_y = cloud_y + cloud_vy * 4
    cloud_x = cloud_x + cloud_vx * 4
    
    #regenerate cloud
    if (cloud_x > 130*4):
        cloud_x = -40*4 
        cloud_y = (random.getrandbits(6) - 22)*4
    elif (cloud_x < -40*4):
        cloud_x = 110*4 
        cloud_y = (random.getrandbits(6) - 22)*4
    elif (cloud_y > 118*4):
        cloud_y = -24*4 
        cloud_x = (random.getrandbits(7)-32)*4
    elif (cloud_y < -34*4):
        cloud_y = 88*4 
        cloud_x = (random.getrandbits(7)-32)*4
        
    #cloud_x = cam_x
    #cloud_y = cam_y
    
def moveship():
    if (debug):
        return
    global ship_wx #ship screen * 4 accuracy
    global ship_wy
    global ship_vx #velocity
    global ship_vy
    global ship_x #screen coords
    global ship_y
    global cam_x #current world position
    global cam_y
    global ship_nudge
    ship_nudge = 0
    owx = ship_wx
    owy = ship_wy
    #get wind effect
    multiplier = wind_strength // 2
    if (multiplier == 0):
        multiplier = 1
    thrust = windangle[ship_dir][wind_dir] * multiplier
    
    #x movement
    if (ship_dir == 1 or ship_dir == 3 ):
        ship_vx = thrust // 2
    elif (ship_dir == 7 or ship_dir ==5 ):
        ship_vx = -thrust // 2
    elif (ship_dir == 2 ):
        ship_vx = thrust
    elif (ship_dir == 6 ):
        ship_vx = -thrust
    #y movement
    if (ship_dir == 1 or ship_dir == 7 ):
        ship_vy = -thrust // 2
    elif (ship_dir == 3 or ship_dir == 5 ):
        ship_vy = thrust // 2
    elif (ship_dir == 0 ):
        ship_vy = -thrust
    elif (ship_dir == 4 ):
        ship_vy = thrust
        
    ship_wx = ship_wx + ship_vx
    ship_wy = ship_wy + ship_vy
    if (ship_wx>70*4 or ship_wx<20*4):
        cam_x = cam_x + ship_vx #move camera instead
        ship_wx = owx
    if (ship_wy>58*4 or ship_wy<20*4):
        cam_y =cam_y + ship_vy  #move camera instead
        ship_wy = owy
    ship_x = ship_wx // 4
    ship_y = ship_wy // 4
        
def moveenemy():
    if (debug):
        return
    global enemy_wx #ship screen * 4 accuracy
    global enemy_wy
    global enemy_vx #velocity
    global enemy_vy
    global enemy_x #screen coords
    global enemy_y
    global cam_x #current world position
    global cam_y
    global enemy_health
    global enemy_slowdown
    global anim_tick
    if (enemy_health <= 1):
        #enemy crashed or standing still
        enemy_x = (enemy_wx - cam_x) // 4
        enemy_y = (enemy_wy - cam_y) // 4
        return
    elif (enemy_health == 2):
        if (animtick%2):
            #enemy is slowed down
            enemy_x = (enemy_wx - cam_x) // 4
            enemy_y = (enemy_wy - cam_y) // 4
            return
    else:
        if (animtick%enemy_slowdown==0):
            #make it possible to catch enemy
            enemy_x = (enemy_wx - cam_x) // 4
            enemy_y = (enemy_wy - cam_y) // 4
            return
        
    #get wind effect
    multiplier = wind_strength // 2
    if (multiplier == 0):
        multiplier = 1
    thrust = windangle[enemy_dir][wind_dir] * multiplier
    
    #x movement
    if (enemy_dir == 1 or enemy_dir == 3 ):
        enemy_vx = thrust // 2
    elif (enemy_dir == 7 or enemy_dir ==5 ):
        enemy_vx = -thrust // 2
    elif (enemy_dir == 2 ):
        enemy_vx = thrust
    elif (enemy_dir == 6 ):
        enemy_vx = -thrust
    #y movement
    if (enemy_dir == 1 or enemy_dir == 7 ):
        enemy_vy = -thrust // 2
    elif (enemy_dir == 3 or enemy_dir == 5 ):
        enemy_vy = thrust // 2
    elif (enemy_dir == 0 ):
        enemy_vy = -thrust
    elif (enemy_dir == 4 ):
        enemy_vy = thrust

    enemy_wx = enemy_wx + enemy_vx 
    enemy_wy = enemy_wy + enemy_vy

    enemy_x = (enemy_wx - cam_x) // 4
    enemy_y = (enemy_wy - cam_y) // 4
    
def initsea():
    for i in range(0,20):    
        _sk = random.getrandbits(2) + 1 
        _sx = random.getrandbits(7) * 4 
        _sy = random.getrandbits(7) * 4
        sea_x[i] = _sx
        sea_y[i] = _sy
        sea_k[i] = _sk
            
def gensea():
    _sk = 0
    _sx = 0
    _sy = 0
    for i in range(0,20):    
        if (random.getrandbits(2) == 0):
            _sk = sea_k[i] 
            _sk = _sk + 1 
            if ( _sk == 3):
                _sk = 1
                _sx = random.getrandbits(7) 
                _sy = random.getrandbits(7)
                sea_x[i] = _sx * 4
                sea_y[i] = _sy * 4
            sea_k[i] = _sk
            
def drawsea():
    #screen_sf.fill()
    for i in range(0,10):
        k = sea_k[i]
        sx = sea_x[i]
        sy = sea_y[i]
        if (k):
            if (k>1):
                screen_sf.blit(sea_sf2 , sx//4, sy//4)
            else:
                screen_sf.blit(sea_sf , sx//4, sy//4)
              
def movesea():
    global cam_x
    global cam_y
    global ocam_x
    global ocam_y
    _dcx = cam_x - ocam_x
    _dcy = cam_y - ocam_y
    _dvx = (cloud_vx // 2) - _dcx
    _dvy = (cloud_vy // 2) - _dcy
    for i in range(0,20):
        sea_x[i] = sea_x[i] + _dvx 
        sea_y[i] = sea_y[i] + _dvy
        if (sea_x[i] < -16*4):
            sea_x[i] = (110-16)*4
        elif (sea_x[i] > 110*4):
            sea_x[i] = 0
        if (sea_y[i] < -16*4):
            sea_y[i] = (88-16)*4
        elif (sea_y[i] > 88*4):
            sea_y[i] = 0
    ocam_x = cam_x
    ocam_y = cam_y
  
def txt(_i,_x,_y,_c):
    pok.draw_text( _x-1, _y, texts[_i], 4)
    pok.draw_text( _x, _y-1, texts[_i], 4)
    pok.draw_text( _x+1, _y, texts[_i], 4)
    pok.draw_text( _x, _y+1, texts[_i], 4)
    pok.draw_text( _x, _y,   texts[_i], _c)

def initgame():
    global rot
    rot = 0
    global cam_x
    cam_x = 0
    global cam_y 
    cam_y = 0
    global ocam_x
    ocam_x = 0
    global ocam_y 
    ocam_y = 0
    global ship_wx
    ship_wx = 44*2
    global ship_wy
    ship_wy = 44*3
    global ship_x
    ship_x = ship_wx // 2
    global ship_y
    ship_y = ship_wy // 2
    global ship_dir
    ship_dir = 2
    global ship_vy
    ship_vy = 0
    global ship_vx
    ship_vx = 0
    global ship_landed
    ship_landed = 0
    global ship_nudge
    ship_nudge = 0
    initisland()
    global grog
    grog=4000
    global points
    points=500
    global old_points
    old_points = points
    global ship_health 
    ship_health = 5

def checklandcollision(_x,_y):
    global ship_x
    global ship_y
    global port_x
    global port_y
    global enemy_x
    global enemy_y
    if ((enemy_x > _x+4 or enemy_x < _x-6 or enemy_y>_y-1 or enemy_y<_y-8)==0):
        enemy_health=0 #crash
    if (ship_x > _x+4 or ship_x < _x-6 or ship_y>_y-1 or ship_y<_y-8):
        return 0
    global ship_nudge 
    ship_nudge = 0
    #check if we are next to a port
    if (ship_x < port_x+16 and ship_x > port_x-14 and ship_y > port_y-10 and ship_y<port_y+10):
        return 3
    return 1

def drawisland():
    global is_x
    global is_y
    global cam_x
    global cam_y
    global animtick
    global ship_landed 
    global port_x
    global port_y
    global islandsize
    isx = (is_x-cam_x)//4
    isy = (is_y-cam_y)//4
    portx = islandport[0]
    porty = islandport[1]
    if (ship_landed < 2):
        ship_landed = 0
    # draw rocks
    if (debug ==0):
        for i in range(0,6):
            if (animtick % 16 > 8):
                screen_sf.blit(rocks, isx+rocks_x[i], isy+rocks_y[i])
            else:
                screen_sf.blit(rocks2, isx+rocks_x[i], isy+rocks_y[i])
            if (checklandcollision(isx+rocks_x[i], isy+rocks_y[i])):
                ship_landed = 2 #Crash!
    #draw land
    for i in range(0,islandsize):
        for j in range(0,islandsize):
            if (island[j][i] != ' '):
                #check if touching ground
                if (ship_landed ==0):
                    ship_landed = checklandcollision(isx+i*8, isy+j*8)
    
                if (island[j][i] == '1'):
                   screen_sf.blit(land1, isx+i*8, isy+j*8)
                elif (island[j][i] == 'T'):
                   screen_sf.blit(land2, isx+i*8, isy+j*8)
                elif (island[j][i] == '3'):
                   screen_sf.blit(land3, isx+i*8, isy+j*8) 
                elif (island[j][i] == 'W'):
                   screen_sf.blit(land4, isx+i*8, isy+j*8) 
                elif (island[j][i] == '#'):
                   screen_sf.blit(land5, isx+i*8, isy+j*8) 
                elif (island[j][i] == 'E'):
                   screen_sf.blit(land6, isx+i*8, isy+j*8) 
                elif (island[j][i] == '7'):
                   screen_sf.blit(land7, isx+i*8, isy+j*8) 
                elif (island[j][i] == 'B'):
                   screen_sf.blit(land8, isx+i*8, isy+j*8) 
                elif (island[j][i] == '9'):
                   screen_sf.blit(land9, isx+i*8, isy+j*8)
                elif (island[j][i] == 'R'):
                   if (animtick % 16 > 8):
                       screen_sf.blit(rocks, isx+i*8, isy+j*8)
                   else:
                       screen_sf.blit(rocks2, isx+i*8, isy+j*8)
                   if (checklandcollision(isx+i*8, isy+j*8)):
                       ship_landed = 2 #Crash!
                   
    if (portx != 0 and porty !=0): 
        screen_sf.blit(port, isx+portx*8, isy+porty*8-4) 
        #store global port coords
        port_x = isx+portx*8
        port_y = isy+porty*8
        if (animtick % 2):
            screen_sf.blit(rflag_sf, isx+portx*8 + 2, isy+porty*8 - 6)
        else:
            screen_sf.blit(rflag2_sf, isx+portx*8 + 2, isy+porty*8 - 6)
            
def regenisland():
    global land_ahoy_counter
    global is_x
    global is_y
    global cam_x
    global cam_y
    global ship_dir
    global ahoy_dir
    if (land_ahoy_counter or ship_ahoy_counter):
        return
    _dx = abs(cam_x-is_x)
    _dy = abs(cam_y-is_y)
    if (_dx > 900 or _dy > 900):
        land_ahoy_counter = 100
        if (_dx > _dy):
            if(random.getrandbits(2)>1):
                ahoy_dir=0
            else:
                ahoy_dir=4
        else:
            if(random.getrandbits(2)>1):
                ahoy_dir=2
            else:
                ahoy_dir=6
        #print(ahoy_dir)
        
        if (ahoy_dir == 0):
            #print("North")
            #print("is_x: "+ str(is_x)+"->"+str(cam_x))
            #print("is_y: "+ str(is_y)+"->"+str(cam_y))
            ahoy_dir = 8 #doubles as shout direction "North!"
            is_x = cam_x + 110 #+ random.getrandbits(7) - 110*4
            is_y = cam_y - 640 #640 #- 440
            initisland()
        elif (ahoy_dir == 2):
            #print("East")
            #print("is_x: "+ str(is_x)+"->"+str(cam_x))
            #print("is_y: "+ str(is_y)+"->"+str(cam_y))
            ahoy_dir = 9 #doubles as shout direction "East!"
            is_y = cam_y #+ random.getrandbits(7) - 110*4
            is_x = cam_x + 640
            initisland()
        elif (ahoy_dir == 4):
            #print("South")
            #print("is_x: "+ str(is_x)+"->"+str(cam_x))
            #print("is_y: "+ str(is_y)+"->"+str(cam_y))
            ahoy_dir = 10 #doubles as shout direction "South!"
            is_x = cam_x +110 #+ random.getrandbits(7) - 110*4
            is_y = cam_y + 640 #+ 440
            initisland()
        elif (ahoy_dir == 6):
            #print("West")
            #print("is_x: "+ str(is_x)+"->"+str(cam_x))
            #print("is_y: "+ str(is_y)+"->"+str(cam_y))
            ahoy_dir = 11 #doubles as shout direction "West!"
            is_y = cam_y #+ random.getrandbits(7) - 110*4
            is_x = cam_x - 640 #- 440
            initisland()

def initenemy():
    global enemy_dir
    global enemy_type
    global enemy_life
    global enemy_health
    global enemy_slowdown
    global enemy_loot
    global ship_dir
    enemy_dir = random.getrandbits(3)
    enemy_life = 10
    enemy_health = 7 - random.getrandbits(2)
    enemy_slowdown = 5 - random.getrandbits(2)
    enemy_loot = random.getrandbits(2)*1000+500
    if(random.getrandbits(2)):
        enemy_dir = (ship_dir+4)%8 # lets make finding ships a bit easier

def spawnenemy():
    global ship_ahoy_counter
    global cam_x
    global cam_y
    global ship_dir
    global ahoy_dir
    global enemy_wx
    global enemy_wy
    if (ship_ahoy_counter or land_ahoy_counter):
        return
    _dx = abs(cam_x-enemy_wx)
    _dy = abs(cam_y-enemy_wy)
    if (_dx > 600 or _dy > 600):
        ship_ahoy_counter = 50
        if (_dx > _dy):
            if(random.getrandbits(2)>1):
                ahoy_dir=0
            else:
                ahoy_dir=4
        else:
            if(random.getrandbits(2)>1):
                ahoy_dir=2
            else:
                ahoy_dir=6
        
        if (ahoy_dir == 0):
            ahoy_dir = 8 #doubles as shout direction "North!"
            enemy_wx = cam_x + 110 + random.getrandbits(3)*20 - 80
            enemy_wy = cam_y - 320 #- 440
            initenemy()
        elif (ahoy_dir == 2):
            ahoy_dir = 9 #doubles as shout direction "East!"
            enemy_wy = cam_y #+ random.getrandbits(7) - 110*4
            enemy_wx = cam_x + 320
            initenemy()
        elif (ahoy_dir == 4):
            ahoy_dir = 10 #doubles as shout direction "South!"
            enemy_wx = cam_x + 110 + random.getrandbits(3)*20 - 80
            enemy_wy = cam_y + 320 #+ 440
            initenemy()
        elif (ahoy_dir == 6):
            ahoy_dir = 11 #doubles as shout direction "West!"
            enemy_wy = cam_y #+ random.getrandbits(7) - 110*4
            enemy_wx = cam_x - 320 #- 440
            initenemy()
            
def enemyattacks():
    global enemy_health
    global ship_x
    global ship_y
    global ship_wx
    global ship_wy
    global enemy_x
    global enemy_y
    global eprojectile_dx
    global eprojectile_dy
    global eprojectile_wx
    global eprojectile_wy
    global esmoke_wx
    global esmoke_wy
    global cam_x
    global cam_y
    global enemy_dir
    global enemy_cannon_counter
    if (enemy_health>1 and enemy_cannon_counter <= 0):
        if (ship_x < enemy_x-30 or ship_x > enemy_x + 30 or ship_y < enemy_y-30 or ship_y > enemy_y + 30):
            return #out of range
        esmoke_wx = enemy_wx + 4
        esmoke_wy = enemy_wy + 8
        eprojectile_wx = esmoke_wx + 8
        eprojectile_wy = esmoke_wy + 12
        #determine projectile direction
        eprojectile_dx = 0
        eprojectile_dy = 0
        pspeed = 2
        #determine multipliers for vectors
        ymult = 0
        xmult = 0
        if (enemy_y > ship_y):
            ymult = -pspeed #shot should travel upwards
        else:
            ymult = pspeed # shot should travel downwards
        if (enemy_x > ship_x):
            xmult = -pspeed #shot should travel left
        else:
            xmult = pspeed # shot should travel right
        #see if we are shooting at an angle ie. ship dir is odd angles (1,3,5,7)  
        if (enemy_dir%2): 
            xmult = xmult //2 
            ymult = ymult //2
        #adjust y-vector if moving N or S
        if (enemy_dir == 0 or enemy_dir == 4):
            ymult = 0
        #adjust x-vector if moving W or E
        if (enemy_dir == 2 or enemy_dir == 6):
            xmult = 0
        #stop firing in impossible directions (aft or fore)
        if (xmult and ymult):
            p_dir=0
            if (xmult < 0):
                if (ymult<0):
                    p_dir = 7 #NW
                else:
                    p_dir = 5 #SW
            else:
                if (ymult<0):
                    p_dir = 1 #NE
                else:
                    p_dir = 3 #SE
            if (p_dir == enemy_dir or (p_dir+4)%8 == enemy_dir):
                ymult = -ymult #flip direction of shot
    
        eprojectile_dx = xmult 
        eprojectile_dy = ymult 
        g_sound.play_sfx(sounds.cannon, len(sounds.cannon), True)
        enemy_cannon_counter = 100
        
def initprojectile(s_dir):
    global projectile_dx
    global projectile_dy
    global enemy_life
    global ship_x
    global ship_y
    global ship_vx
    global ship_vy
    global enemy_x
    global enemy_y
    projectile_dx = 0
    projectile_dy = 0
    pspeed = 2
    #determine multipliers for vectors
    ymult = 0
    xmult = 0
    if (enemy_y < ship_y):
        ymult = -pspeed #shot should travel upwards
    else:
        ymult = pspeed # shot should travel downwards
    if (enemy_x < ship_x):
        xmult = -pspeed #shot should travel left
    else:
        xmult = pspeed # shot should travel right
    #see if we are shooting at an angle ie. ship dir is odd angles (1,3,5,7)  
    if (s_dir%2): 
        xmult = xmult //2 
        ymult = ymult //2
    #adjust y-vector if moving N or S
    if (s_dir == 0 or s_dir == 4):
        ymult = 0
    #adjust x-vector if moving W or E
    if (s_dir == 2 or s_dir == 6):
        xmult = 0
    #stop firing in impossible directions (aft or fore)
    if (xmult and ymult):
        p_dir=0
        if (xmult < 0):
            if (ymult<0):
                p_dir = 7 #NW
            else:
                p_dir = 5 #SW
        else:
            if (ymult<0):
                p_dir = 1 #NE
            else:
                p_dir = 3 #SE
        if (p_dir == s_dir or (p_dir+4)%8 == s_dir):
            ymult = -ymult #flip direction of shot
    
    projectile_dx = xmult 
    projectile_dy = ymult 
      
def checkshothit(px,py,sx,sy):
    if (px > sx+10 or px < sx or py>sy+4 or py<sy):
        return 0
    return 1
    
def checkshipcollision(ex,ey,sx,sy):
    if (ex > sx+8 or ex < sx-8 or ey > sy + 4 or ey < sy-4):
        return 0
    return 1

def moveprojectile():
    global projectile_wx 
    global projectile_wy
    global projectile_dx 
    global projectile_dy
    global cam_x
    global cam_y
    projectile_wx = projectile_wx + projectile_dx
    projectile_wy = projectile_wy + projectile_dy

def emoveprojectile():
    global eprojectile_wx 
    global eprojectile_wy
    global eprojectile_dx 
    global eprojectile_dy
    global cam_x
    global cam_y
    eprojectile_wx = eprojectile_wx + eprojectile_dx
    eprojectile_wy = eprojectile_wy + eprojectile_dy
    
def drawsail(life,x,y):
    global wind_dir
    if (life < 2):
        screen_sf.blit(sail_broken, x, y)
        return
    if wind_dir == 0:
        screen_sf.blit(sail_n, x, y)
    elif wind_dir == 1:
        screen_sf.blit(sail_e, x, y)
    elif wind_dir == 2:
        screen_sf.blit(sail_e, x, y)
    elif wind_dir == 3:
        screen_sf.blit(sail_e, x, y)
    elif wind_dir == 4:
        screen_sf.blit(sail_n, x, y)
    elif wind_dir == 5:
        screen_sf.blit(sail_w, x, y)
    elif wind_dir == 6:
        screen_sf.blit(sail_w, x, y)
    else:
        screen_sf.blit(sail_w, x, y)
        
def drawhull(health, dir,x,y):
    if (health == 0):
        screen_sf.blit(crash, x, y)
    elif dir == 0:
        screen_sf.blit(hull_n, x, y)
    elif dir == 1:
        screen_sf.blit(hull_ne, x, y)
    elif dir == 2:
        screen_sf.blit(hull_e, x, y)
    elif dir == 3:
        screen_sf.blit(hull_se, x, y)
    elif dir == 4:
        screen_sf.blit(hull_s, x, y)
    elif dir == 5:
        screen_sf.blit(hull_sw, x, y)
    elif dir == 6:
        screen_sf.blit(hull_w, x, y)
    else:
        screen_sf.blit(hull_nw, x, y)
        
def drawflag(t,x,y):
    global enemy_health
    if (enemy_health==0):
        return
    if (animtick % 2):
        if (t):
            if (enemy_health>1):
                screen_sf.blit(rflag2_sf, x + 5, y - 2)
            else:
                screen_sf.blit(wflag2_sf, x + 5, y - 2)
        else:
            screen_sf.blit(flag2_sf, x + 5, y - 2)
    else:
        if (t):
            if (enemy_health>1):
                screen_sf.blit(rflag_sf, x + 5, y - 2)
            else:
                screen_sf.blit(wflag_sf, x + 5, y - 2)
        else:
            screen_sf.blit(flag_sf, x + 5, y - 2)

rot = 0
animtick = 0
initsea()
initwind() 
initrocks(is_x,is_y)
initisland()
moveship()
old_points = points
while True:
    
    #random changes in environment
    if (random.getrandbits(4)==0):
        if (random.getrandbits(2)==0):
            initwind()
        if (random.getrandbits(2)):
            regenisland()
        else:
            spawnenemy()
    
    eventtype = upygame.event.poll()
    if eventtype != upygame.NOEVENT:
        if eventtype.type== upygame.KEYDOWN:
            if eventtype.key == upygame.K_RIGHT:
                vx = 1
                ship_dir = ship_dir + 1
                if ship_dir == 8:
                    ship_dir = 0
            if eventtype.key == upygame.K_LEFT:
                vx = -1
                ship_dir = ship_dir - 1
                if ship_dir < 0:
                    ship_dir = 7
            if eventtype.key == upygame.K_UP:
                vy = -1
            if eventtype.key == upygame.K_DOWN:
                vy = 1
        if eventtype.type == upygame.KEYUP:
            if eventtype.key == upygame.K_RIGHT:
                if (ship_landed<2):
                    ship_nudge = 1
            if eventtype.key == upygame.K_LEFT:
                if (ship_landed<2):
                    ship_nudge = 1
            if eventtype.key == upygame.K_UP:
                if (debug):
                    wind_dir = 0
            if eventtype.key == upygame.K_DOWN:
                if (debug):
                    wind_dir = 4
            if eventtype.key == upygame.BUT_B:
                if (ship_landed != 2):
                    ship_landed = ship_landed #do nothinh
            if eventtype.key == upygame.BUT_A:
                if (ship_landed == 4):
                    random.getrandbits(7)
                    ship_landed = 5
                elif (ship_landed == 5):
                    random.getrandbits(7)
                    ship_landed = 6
                elif (ship_landed == 6):
                    random.getrandbits(7)
                    ship_landed = 7
                elif (ship_landed == 7):
                    random.getrandbits(7)
                    regenisland()
                    initisland()
                    ship_landed = 0
                elif (ship_landed == 3):
                    ship_landed = 0
                    moveship()
                    moveship()
                    moveship()
                else:
                    #fire cannon
                    if (player_cannon_counter == 0 and ship_landed == 0):
                        smoke_wx = ship_wx + cam_x + 4
                        smoke_wy = ship_wy + cam_y + 8
                        projectile_wx = smoke_wx + 8
                        projectile_wy = smoke_wy + 8
                        #determine projectile direction
                        initprojectile(ship_dir)
                        g_sound.play_sfx(sounds.cannon, len(sounds.cannon), True)
                        player_cannon_counter = 100
                        
            if eventtype.key == upygame.BUT_C:
                if (ship_landed < 4):
                    random.getrandbits(7)
                    initisland()
                    initgame()
                    if (debug):
                        ship_x = ship_wx // 4
                        ship_y = ship_wy // 4
                        enemy_wx = ship_wx 
                        enemy_wy = ship_wy - 120 
                        enemy_x = (enemy_wx - cam_x) // 4
                        enemy_y = (enemy_wy - cam_y) // 4
                        enemy_dir = 2
                    
                
   
    drawsea()
    movecloud()
    movesea()
    if (ship_nudge and ship_landed == 1):
        moveship()
    
    _xoff = 8 # offset for wake
    if (ship_dir == 0 or ship_dir == 4):
        _xoff = 0
  
    if (animtick % 2):
        gensea()
        if (ship_landed == 0):
            screen_sf.blit(wake_sf, ship_x + _xoff - ship_vx * 2, ship_y + 8 - ship_vy * 2)
            screen_sf.blit(wake2_sf, ship_x + _xoff - ship_vx * 4, ship_y + 8 - ship_vy * 4)
        if (enemy_health):
            screen_sf.blit(wake_sf, enemy_x + _xoff - enemy_vx * 2, enemy_y + 8 - enemy_vy * 2)
            if (enemy_health>1):
                screen_sf.blit(wake2_sf, enemy_x + _xoff - enemy_vx * 4, enemy_y + 8 - enemy_vy * 4)
    else:
        if (ship_landed == 0):
            screen_sf.blit(wake2_sf, ship_x + _xoff - ship_vx * 2, ship_y + 8 - ship_vy * 2)
            screen_sf.blit(wake_sf, ship_x + _xoff - ship_vx * 4, ship_y + 8 - ship_vy * 4)
        if (enemy_health>1):
            screen_sf.blit(wake2_sf, enemy_x + _xoff - enemy_vx * 2, enemy_y + 8 - enemy_vy * 2)
            if (enemy_health>2):
                screen_sf.blit(wake_sf, enemy_x + _xoff - enemy_vx * 4, enemy_y + 8 - enemy_vy * 4)
        
    
    drawisland()
        
    if (debug):
        pok.draw_text( 0, 8, str(wind_strength), 3)
        pok.draw_text( 0, 15, str(cam_x), 7)
        pok.draw_text( 0, 15+8, str(cam_y), 7)
        pok.draw_text( 0, 15+16, str(is_x), 13)
        pok.draw_text( 0, 15+24, str(is_y), 13)
        pok.draw_text( 0, 15+32, str(land_ahoy_counter), 13)
        
        
    #draw enemy sail and hull if behind
    if(enemy_y <= ship_y):
        drawsail(enemy_health, enemy_x, enemy_y)
        drawhull(enemy_health,enemy_dir,enemy_x,enemy_y)
        drawflag(1,enemy_x,enemy_y)

    #draw player sail
    if (ship_landed == 0):
        drawsail(ship_health,ship_x, ship_y)
    
    #draw player hull
    if (ship_landed != 2):
        drawhull(ship_health,ship_dir, ship_x, ship_y)
        drawflag(0,ship_x,ship_y)
    else:
        screen_sf.blit(crash, ship_x, ship_y)
    
    #draw enemy if below player
    if(enemy_y > ship_y):
        drawsail(enemy_health, enemy_x, enemy_y)
        drawhull(enemy_health,enemy_dir,enemy_x,enemy_y)
        drawflag(1,enemy_x,enemy_y)
        
    #draw grog counter
    if (ship_landed==0 or ship_landed==3):
        for i in range(0,grog//36,10):
            screen_sf.blit(grog_sf,i,79)
    
    if (animtick%2):
        grog = grog - 1
        if (points>10000):
            grog = grog - 1
        if (points>20000):
            grog = grog - 1
        
    
    #draw cloud
    screen_sf.blit(cloud_sf, cloud_x//4, cloud_y//4)
    
    if (random.getrandbits(5)==0):
        enemyattacks() #if possible, enemy fires at player
    if (random.getrandbits(6)==0):
        if (random.getrandbits(6)%2):
            enemy_dir = (enemy_dir + 1)%8
        else:
            enemy_dir = (enemy_dir - 1)%8
            
    
    #draw cannon shot
    if (player_cannon_counter):
        
        enemyhit = checkshothit((projectile_wx-cam_x)//4,(projectile_wy-cam_y)//4,enemy_x,enemy_y)
        if (enemyhit==0):
            moveprojectile()
        enemyhit = checkshothit((projectile_wx-cam_x)//4,(projectile_wy-cam_y)//4,enemy_x,enemy_y)
        if (enemyhit==0):
            moveprojectile()
        enemyhit = checkshothit((projectile_wx-cam_x)//4,(projectile_wy-cam_y)//4,enemy_x,enemy_y)
        if (enemyhit==0):
            moveprojectile()
        enemyhit = checkshothit((projectile_wx-cam_x)//4,(projectile_wy-cam_y)//4,enemy_x,enemy_y)
        if (enemyhit):
            if (player_cannon_counter > 9):
                if (enemy_health):
                    enemy_health = enemy_health - 1
                player_cannon_counter = 10 #go directly to boom
        
        player_cannon_counter = player_cannon_counter - 4
        if (player_cannon_counter < 0):
            player_cannon_counter = 0
        if (player_cannon_counter>90):
            screen_sf.blit(shotm, (smoke_wx-cam_x)//4, (smoke_wy-cam_y)//4)
            screen_sf.blit(projlo, (projectile_wx-cam_x)//4, (projectile_wy-cam_y)//4)
        if (player_cannon_counter>66):
            screen_sf.blit(shotl, (smoke_wx-cam_x)//4, (smoke_wy-cam_y)//4)
            screen_sf.blit(projhi, (projectile_wx-cam_x)//4, (projectile_wy-cam_y)//4)
        elif (player_cannon_counter>33):
            screen_sf.blit(shotm, (smoke_wx-cam_x)//4, (smoke_wy-cam_y)//4)
            screen_sf.blit(projhi, (projectile_wx-cam_x)//4, (projectile_wy-cam_y)//4)
        else:
            screen_sf.blit(shotm, (smoke_wx-cam_x)//4, (smoke_wy-cam_y)//4)
            if (player_cannon_counter<10):
                if (enemyhit):
                    screen_sf.blit(boom, (projectile_wx-cam_x)//4, (projectile_wy-cam_y)//4+5)
                else:
                    screen_sf.blit(splash, (projectile_wx-cam_x)//4, (projectile_wy-cam_y)//4)
            else:
                screen_sf.blit(projlo, (projectile_wx-cam_x)//4, (projectile_wy-cam_y)//4)
    
    #ENEMY SHOT
    if (enemy_cannon_counter):
        
        enemyhit = checkshothit((eprojectile_wx-cam_x)//4,(eprojectile_wy-cam_y)//4,ship_x,ship_y)
        if (enemyhit==0):
            emoveprojectile()
        enemyhit = checkshothit((eprojectile_wx-cam_x)//4,(eprojectile_wy-cam_y)//4,ship_x,ship_y)
        if (enemyhit==0):
            emoveprojectile()
        enemyhit = checkshothit((eprojectile_wx-cam_x)//4,(eprojectile_wy-cam_y)//4,ship_x,ship_y)
        if (enemyhit==0):
            emoveprojectile()
        enemyhit = checkshothit((eprojectile_wx-cam_x)//4,(eprojectile_wy-cam_y)//4,ship_x,ship_y)
        if (enemyhit):
            if (enemy_cannon_counter > 9):
                if (ship_health):
                    ship_health = ship_health - 1
                    if (ship_health == 0):
                        ship_landed = 2 #crash
                enemy_cannon_counter = 10 #go directly to boom
        
        enemy_cannon_counter = enemy_cannon_counter - 4
        #if (enemy_cannon_counter < 0):
        #    enemy_cannon_counter = 0
        if (enemy_cannon_counter>90):
            screen_sf.blit(shotm, (esmoke_wx-cam_x)//4, (esmoke_wy-cam_y)//4)
            screen_sf.blit(projlo, (eprojectile_wx-cam_x)//4, (eprojectile_wy-cam_y)//4)
        if (enemy_cannon_counter>66):
            screen_sf.blit(shotl, (esmoke_wx-cam_x)//4, (esmoke_wy-cam_y)//4)
            screen_sf.blit(projhi, (eprojectile_wx-cam_x)//4, (eprojectile_wy-cam_y)//4)
        elif (enemy_cannon_counter>33):
            screen_sf.blit(shotm, (esmoke_wx-cam_x)//4, (esmoke_wy-cam_y)//4)
            screen_sf.blit(projhi, (eprojectile_wx-cam_x)//4, (eprojectile_wy-cam_y)//4)
        else:
            screen_sf.blit(shotm, (esmoke_wx-cam_x)//4, (esmoke_wy-cam_y)//4)
            if (enemy_cannon_counter<10):
                if (enemyhit):
                    screen_sf.blit(boom, (eprojectile_wx-cam_x)//4, (eprojectile_wy-cam_y)//4+5)
                else:
                    screen_sf.blit(splash, (eprojectile_wx-cam_x)//4, (eprojectile_wy-cam_y)//4)
            else:
                screen_sf.blit(projlo, (eprojectile_wx-cam_x)//4, (eprojectile_wy-cam_y)//4)
                
    ## SHIP STATE
    
    if (ship_landed ==2):
        ship_nudge = 0 #the ship is crashed
    if (ship_landed == 0 or ship_nudge):
        moveship()
        #check what happens if ships collide
        if (checkshipcollision(enemy_x,enemy_y,ship_x,ship_y)):
            if (enemy_health == 0):
                ship_landed = 2 #crash
                screen_sf.blit(boom, ship_x+2, ship_y+4)
                g_sound.play_sfx(sounds.cannon, len(sounds.cannon), True)
            elif (enemy_health == 1):
                if (enemy_loot>0):
                    points = points + 100
                    enemy_loot = enemy_loot - 100
                    if (points - old_points >= 300): 
                        g_sound.play_sfx(sounds.piratejig, len(sounds.cannon)//4, True)
                        old_points = points #stop constant ringing
                    if (animtick%2):
                        screen_sf.blit(coin, ship_x+2, ship_y+4)
                    else:
                        screen_sf.blit(boom, ship_x+2, ship_y+4)
            else:
                enemy_health = enemy_health - 1
                ship_health = ship_health - 1
                if (ship_health == 0):
                    ship_landed = 2 #crash
                    
                screen_sf.blit(boom, (ship_x+enemy_x)//2, (ship_y+enemy_y)//2)
                g_sound.play_sfx(sounds.cannon, len(sounds.cannon), True)
                ship_dir = (ship_dir+4)%8
                enemy_dir = random.getrandbits(3)
                moveship()
                moveenemy()
                
    if (enemy_life):
        moveenemy()
        
    #wind indicator 
    if wind_dir == 0:
        screen_sf.blit(wind0, 0, 0)
    elif wind_dir == 1:
        screen_sf.blit(wind1, 0, 0)
    elif wind_dir == 2:
        screen_sf.blit(wind2, 0, 0)
    elif wind_dir == 3:
        screen_sf.blit(wind3, 0, 0)
    elif wind_dir == 4:
        screen_sf.blit(wind4, 0, 0)
    elif wind_dir == 5:
        screen_sf.blit(wind5, 0, 0)
    elif wind_dir == 6:
        screen_sf.blit(wind6, 0, 0)
    else:
        screen_sf.blit(wind7, 0, 0)
    
    rs = 13
    
    if (ship_landed == 1):
        txt(1,22,3*rs,3) #Landed!
    elif (ship_landed ==2):
        if (grog>0):
            txt(2,22,3*rs,3) #Crashed!
    elif (ship_landed ==3):
        txt(3,1,3*rs,3) #In Port
        if (port_visited==0):
            if (ship_health<5):
                points = points - (5 - ship_health)*100 #fixing ship
                ship_health = 5
            if (port_grog and points >= 10 and grog < 4000):
                points = points - 10
                grog = grog + 100
                port_grog = port_grog -100
            else:
                port_visited=1
            #if (old_points - points > 100):
            g_sound.play_sfx(sounds.piratejig, len(sounds.piratejig), True)
                #old_points = points
    elif (ship_landed ==4):
        txt(0,22,2*rs,7) #Pyrates!
        txt(4,22,4*rs,3) #by jonne
        txt(12,22,5*rs,7) #press A
    elif (ship_landed ==5):
        txt(5,8,4*rs,3) #Instructions
    elif (ship_landed ==6):
        txt(6,8,4*rs,3) #Instructions2
    elif (ship_landed ==7):
        txt(13,8,4*rs,3) #Instructions2
    if (land_ahoy_counter):
        txt(7,22,rs,3)
        txt(ahoy_dir,22,rs*2,3)
        land_ahoy_counter = land_ahoy_counter - 2
    elif (ship_ahoy_counter):
        txt(18,22,rs,3)
        txt(ahoy_dir,22,rs*2,3)
        ship_ahoy_counter = ship_ahoy_counter - 2
    elif (grog<2000 and grog>1900):
        txt(14,8,3*rs,3)
        txt(15,8,4*rs,3)
    elif (grog<1000 and grog>900):
        txt(14,8,3*rs,3)
        txt(15,8,4*rs,3)
    if (grog<1):
        txt(16,8,4*rs,3)
        txt(17,8,5*rs,3)
        ship_landed=2
    
    _cx = 96
    if (points>9):
        _cx=_cx - 10
    if (points>99):
        _cx=_cx - 10
    if (points>999):
        _cx=_cx - 10
    if (points>9999):
        _cx=_cx - 10
    screen_sf.blit(coin, _cx-10, 0)
    pok.draw_text( _cx, 0, str(points), 7)
    
    
        
    upygame.display.flip()
    animtick = animtick+1
